diff -ur sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2019-06-22 07:43:44.237400000 +1000
+++ source/scripts/jmgBearHunter.cpp	2019-08-20 10:11:06.805000100 +1000
@@ -7428,15 +7938,202 @@
 			{
 				Remove_Script(obj,"JMG_Bear_Hunter_AI_Ignore_Up_To_75_Meters");
 				Commands->Set_Animation(obj,"ArmoredCar.ArmoredCar",false,0,1,1,true);
+				GameObject *driver = Get_Vehicle_Driver(obj);
+				if (driver)
+					Set_Object_Visibility_For_Player(driver,effectRangeId,true);
 			}
 			else
 			{
 				Attach_Script_Once(obj,"JMG_Bear_Hunter_AI_Ignore_Up_To_75_Meters","");
 				Commands->Set_Animation(obj,"ArmoredCar.ArmoredCar",false,0,0,0,true);
+				GameObject *driver = Get_Vehicle_Driver(obj);
+				if (driver)
+					Set_Object_Visibility_For_Player(driver,effectRangeId,false);
 			}
 		}
 		Commands->Start_Timer(obj,this,0.1f,1);
 	}
+	if (number == 2)
+	{
+		GameObject *owner = Get_Vehicle_Owner(obj);
+		if (owner)
+			ownerNode = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(owner));
+	}
+	if (number == 3)
+	{
+		for (int x = 1;x < 128;x++)
+		{
+			GameObject *player = Get_GameObj(x);
+			if (player)
+				Set_Object_Visibility_For_Player(player,effectRangeId,false);
+		}
+	}
+}
+void JMG_Bear_Hunter_Armored_Car::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
+	{
+		GameObject *driver = Get_Vehicle_Driver(obj);
+		if (driver && sender == driver && lightsOn)
+			Set_Object_Visibility_For_Player(driver,effectRangeId,true);
+	}
+	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
+	{
+		if (lightsOn)
+			Set_Object_Visibility_For_Player(sender,effectRangeId,false);
+	}
+}
+void JMG_Bear_Hunter_Armored_Car::Destroyed(GameObject *obj)
+{
+	GameObject *effect = Commands->Find_Object(effectRangeId);
+	if (effect)
+		Commands->Destroy_Object(effect);
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::Created(GameObject *obj)
+{
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1 && !The_Game()->Is_Game_Over())
+	{
+		for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+		{
+			SmartGameObj *armoredCar = current->Data();
+			if (!armoredCar || !Is_Script_Attached(armoredCar,"JMG_Bear_Hunter_Armored_Car"))
+				continue;
+			JMG_Bear_Hunter_Armored_Car *script = (JMG_Bear_Hunter_Armored_Car*)Find_Script_On_Object(armoredCar,"JMG_Bear_Hunter_Armored_Car");
+			if (!script || !script->lightsOn)
+				continue;
+			ArmoredCarSupport(armoredCar,script->ownerNode);
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::ArmoredCarSupport(GameObject *obj,BearHunterScoreSystem::BHScoreNode *ownerNode)
+{
+	Vector3 myPos = Commands->Get_Position(obj);
+	for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+	{
+		SmartGameObj *o = current->Data();
+		if (!o || Is_Script_Attached(o,"JMG_Bear_Hunter_Armored_Car") || Commands->Get_Player_Type(o) != 1)
+			continue;
+		if (JmgUtility::SimpleDistance(Commands->Get_Position(o),myPos) > 5625.0f)
+			continue;
+		if (o->As_SoldierGameObj())
+		{
+			if (Get_Vehicle(o))
+				continue;
+			JMG_Bear_Hunter_Player_Soldier *script = (JMG_Bear_Hunter_Player_Soldier*)Find_Script_On_Object(o,"JMG_Bear_Hunter_Player_Soldier");
+			if (!script)
+				continue;
+			if (!script->lastDamaged)
+				RegenHp(o,ownerNode);
+			const char *weap = Get_Current_Weapon(o);
+			if (!weap || !_stricmp(weap,"Weapon_Binoculars") || !_stricmp(weap,"Weapon_Needle") || !_stricmp(weap,"Weapon_Golden_Deer_Statue") || !_stricmp(weap,"Weapon_Weapons_Container") || !_stricmp(weap,"Weapon_Sentry_Gun_Beacon"))
+				script->armoredCarWeapon.Reset();
+			if (_stricmp(script->armoredCarWeapon.weaponName,weap))
+			{
+				script->armoredCarWeapon.Reset();
+				sprintf(script->armoredCarWeapon.weaponName,"%s",weap);
+				script->armoredCarWeapon.calculatedGrant = Get_Max_Total_Bullets(o,weap)/150.0;
+			}
+			int currentBullets = Get_Total_Bullets(o,weap);
+			int maxTotalBullets = Get_Max_Total_Bullets(o,weap);
+			if (currentBullets < script->armoredCarWeapon.lastammo)
+				script->armoredCarWeapon.Reset();
+			if (!script->armoredCarWeapon.lastFireTime && currentBullets < maxTotalBullets)
+			{
+				script->armoredCarWeapon.addedGrant += script->armoredCarWeapon.calculatedGrant;
+				double ammoClips;
+				script->armoredCarWeapon.addedGrant = modf(script->armoredCarWeapon.addedGrant,&ammoClips);
+				int finalClips = (int)JmgUtility::MathClampDouble(ammoClips,0.0,(double)(maxTotalBullets-currentBullets));
+				if (finalClips)
+				{
+					Set_Clip_Bullets(o,weap,Get_Clip_Bullets(o,weap)+finalClips);
+					if (ownerNode && !_stricmp(Get_Player_Name(o),ownerNode->PlayerName))
+						bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(o))->SupportReceivedAmmoSelf += finalClips;
+					else
+						bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(o))->SupportReceivedAmmo += finalClips;
+					if (ownerNode)
+					{
+						ownerNode->SupportGrantedAmmo += finalClips;
+						GrantScore(ownerNode->PlayerName,(float)(finalClips*(1.0f/(float)maxTotalBullets)));
+					}
+				}
+			}
+			script->armoredCarWeapon.lastammo = Get_Total_Bullets(o,weap);
+		}
+		if (o->As_VehicleGameObj())
+		{
+			JMG_Bear_Hunter_Player_Vehicle *script = (JMG_Bear_Hunter_Player_Vehicle*)Find_Script_On_Object(o,"JMG_Bear_Hunter_Player_Vehicle");
+			if (!script || script->lastDamaged)
+				continue;
+			RegenHp(o,ownerNode);
+		}
+	}
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::RegenHp(GameObject *obj,BearHunterScoreSystem::BHScoreNode *ownerNode)
+{
+	GameObject *owner = Get_Vehicle_Driver(obj);
+	if (!owner)
+		owner = obj;
+	float maxHealth = Commands->Get_Max_Health(obj);
+	float maxShield = Commands->Get_Max_Shield_Strength(obj);
+	if (Commands->Get_Health(obj) < maxHealth)
+	{
+		float grantHp = maxHealth/300.0f;
+		Commands->Set_Health(obj,Commands->Get_Health(obj)+grantHp);
+		if (Commands->Get_Health(obj) > maxHealth)
+			Commands->Set_Health(obj,maxHealth);
+		DecideScoreVehicleOrInfantry(obj,owner,ownerNode,grantHp);
+	}
+	else if (Commands->Get_Shield_Strength(obj) < maxShield)
+	{
+		float grantHp = maxShield/300.0f;
+		Commands->Set_Shield_Strength(obj,Commands->Get_Shield_Strength(obj)+grantHp);
+		if (Commands->Get_Shield_Strength(obj) > maxShield)
+			Commands->Set_Shield_Strength(obj,maxShield);
+		DecideScoreVehicleOrInfantry(obj,owner,ownerNode,grantHp);
+	}
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::GrantScore(const char *playerName,float score)
+{
+	GameObject *player = Get_GameObj_By_Player_Name(playerName);
+	if (!player)
+		return;
+	Commands->Give_Points(player,score,false);
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::DecideScoreVehicleOrInfantry(GameObject *obj,GameObject *owner,BearHunterScoreSystem::BHScoreNode *ownerNode,float grantHp)
+{
+	if (obj->As_SoldierGameObj())
+		GrantInfantryRepairScore(obj,owner,ownerNode,grantHp);
+	if (obj->As_VehicleGameObj())
+		GrantVehicleRepairScore(obj,owner,ownerNode,grantHp);
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::GrantVehicleRepairScore(GameObject *obj,GameObject *owner,BearHunterScoreSystem::BHScoreNode *ownerNode,float grantHp)
+{
+	if (ownerNode && !_stricmp(Get_Player_Name(owner),ownerNode->PlayerName))
+		bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(owner))->tmpSupportReceivedHpVehicleSelf += grantHp;
+	else
+		bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(owner))->tmpSupportReceivedVehicleHp += grantHp;
+	if (ownerNode)
+	{
+		GrantScore(ownerNode->PlayerName,grantHp*Get_Damage_Points(obj)*0.5f);
+		ownerNode->tmpSupportGrantedHpVehicle += grantHp;
+	}
+}
+void JMG_Bear_Hunter_Armored_Car_Controller::GrantInfantryRepairScore(GameObject *obj,GameObject *owner,BearHunterScoreSystem::BHScoreNode *ownerNode,float grantHp)
+{
+	if (ownerNode && !_stricmp(Get_Player_Name(owner),ownerNode->PlayerName))
+		bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(owner))->tmpSupportReceivedHpInfantrySelf += grantHp;
+	else
+		bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(owner))->tmpSupportReceivedInfantryHp += grantHp;
+	if (ownerNode)
+	{
+		GrantScore(ownerNode->PlayerName,grantHp*Get_Damage_Points(obj)*0.5f);
+		ownerNode->tmpSupportGrantedHpInfantry += grantHp;
+	}
 }
 void JMG_Bear_Hunt_Final_Boss_Support::Created(GameObject *obj)
 {// You're doing to good if you see these guys
@@ -7729,7 +8426,8 @@
 	{
 		if (NewObjectiveSystemControl.Get_Objective_Status(24) == NewObjectiveSystem::NotDefined)
 		{
-			JmgUtility::MessageAllPlayers(127,127,255,"San Casina Rug Co: Not only does that statue look valuable, but those little tiny deer seem to love it, bring it back to base!");
+			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Not only does that statue look valuable, but those little tiny deer seem to love it, bring it back to base!");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH94.mp3");
 			NewObjectiveSystemControl.Add_Objective(24,NewObjectiveSystem::Tertiary,NewObjectiveSystem::Pending,12821,"",12821,JMG_Bear_Hunter_Game_Control::centerOfBase);
 		}
 		else
@@ -7794,7 +8492,8 @@
 		{
 			Remove_Weapon(obj,"Weapon_Golden_Deer_Statue");
 			JMG_Bear_Hunter_Golden_Deer_Statue::playerWithTheStatue = 0;
-			JmgUtility::MessageAllPlayers(127,127,255,"San Casina Rug Co: We've placed the deer statue on the power substation, tiny deer will now guard it with their lives!");
+			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We've placed the deer statue on the power substation, those tiny deer will now guard it with their lives!");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH95.mp3");
 			bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(obj))->ReturnedDeerStatue++;
 			Commands->Give_Money(obj,500.0f,false);
 			NewObjectiveSystemControl.Set_Objective_Status(24,NewObjectiveSystem::Accomplished);
@@ -7902,6 +8601,178 @@
 void JMG_Security_Camera_Behavior_Ignore::Created(GameObject *obj)
 {
 }
+void JMG_Bear_Hunter_Friendly_Cougar::Created(GameObject *obj)
+{
+	gotoId = 0;
+	LastSeen = 0;
+	currentTargetID = 0;
+	secondaryTargetId = 0;
+	lastSeenSecondary = 0;
+	huntorattack = 0;
+	waitcount = 0;
+	speed = 2.0f;
+	stuckTime = 0;
+	movingSlow = false;
+	lastPos = homelocation = Commands->Get_Position(obj);
+	noPathfindRange = Get_Float_Parameter("NoPathfindDistance")*Get_Float_Parameter("NoPathfindDistance");
+	minVisibilityTime = Get_Int_Parameter("MinLooseVisibilityTime")*10;
+	maxVisibilityTime = Get_Int_Parameter("MaxLooseVisibilityTime")*10;
+	maxHuntDistance = Get_Float_Parameter("MaxHuntDistance")*Get_Float_Parameter("MaxHuntDistance");
+	Commands->Enable_Enemy_Seen(obj,true);
+	Commands->Start_Timer(obj,this,0.1f,92562343);
+}
+void JMG_Bear_Hunter_Friendly_Cougar::Enemy_Seen(GameObject *obj,GameObject *seen)	
+{
+	if (!Commands->Get_Health(seen))
+		return;
+	if (Is_Script_Attached(seen,"JMG_Bear_Hunter_AI_Avoid_Enemies") ||  Is_Script_Attached(seen,"JMG_Utility_AI_Skittish_Herd_Animal"))
+		return;
+	int SeenID = Commands->Get_ID(seen);
+	if (!currentTargetID || !LastSeen)
+	{
+		gotoId = 0;
+		LastSeen = minVisibilityTime == maxVisibilityTime ? maxVisibilityTime : Commands->Get_Random_Int(minVisibilityTime,maxVisibilityTime);
+		huntorattack = 0;
+		currentTargetID = SeenID;
+	}
+	else if (currentTargetID == SeenID)
+		LastSeen = minVisibilityTime == maxVisibilityTime ? maxVisibilityTime : Commands->Get_Random_Int(minVisibilityTime,maxVisibilityTime);
+	else if (!secondaryTargetId || !lastSeenSecondary)
+	{
+		gotoId = 0;
+		lastSeenSecondary = maxVisibilityTime;
+		secondaryTargetId = SeenID;
+	}
+	else if (secondaryTargetId == SeenID)
+		lastSeenSecondary = maxVisibilityTime;
+}
+void JMG_Bear_Hunter_Friendly_Cougar::Timer_Expired(GameObject *obj,int number)
+{
+	if (92562343 == number)
+	{
+		if (LastSeen)
+		{
+			LastSeen--;
+			if (!LastSeen)
+				currentTargetID = 0;
+		}
+		if (lastSeenSecondary)
+		{
+			lastSeenSecondary--;
+			if (!lastSeenSecondary)
+				secondaryTargetId = 0;
+		}
+		if (gotoId)
+		{
+			if (!Commands->Find_Object(gotoId))
+				gotoId = 0;
+		}
+		if (currentTargetID)
+		{
+			GameObject *target = Commands->Find_Object(currentTargetID);
+			GameObject *target2 = Commands->Find_Object(secondaryTargetId);
+			if (!target2 || Commands->Get_Health(target2) == 0.0f)
+				secondaryTargetId = 0;
+			if (!target || Commands->Get_Health(target) == 0.0f)
+			{
+				if (target2)
+				{
+					currentTargetID = secondaryTargetId;
+					LastSeen = maxVisibilityTime;
+				}
+				else
+					FollowPlayer(obj,false);
+			}
+			else if (Get_Float_Parameter("MaxHuntDistance") && JmgUtility::SimpleDistance(homelocation,Commands->Get_Position(target)) > maxHuntDistance)
+			{
+				currentTargetID = 0;
+				waitcount = 0;
+				if (huntorattack == 1)
+					Commands->Action_Reset(obj,10);
+			}
+			else
+			{
+				waitcount++;
+				if (waitcount > 2)
+				{
+					waitcount = 0;
+					ActionParamsStruct params;
+					params.Set_Movement(target,Get_Float_Parameter("ChaseSpeed"),Get_Float_Parameter("AttackArriveDistance"),false);
+					params.MovePathfind = JmgUtility::SimpleDistance(Commands->Get_Position(target),Commands->Get_Position(obj)) <= noPathfindRange ? false : true;
+					Commands->Action_Goto(obj,params);
+					params.Set_Basic(this,999,10);
+					params.Set_Attack(target,Get_Float_Parameter("StartAttackDistance"),1,true);
+					Commands->Action_Attack(obj,params);
+				}
+			}
+		}
+		if (!secondaryTargetId && !currentTargetID)
+		{
+			if (!gotoId)
+				FollowPlayer(obj,false);
+			else
+			{
+				GameObject *player = Commands->Find_Object(gotoId);
+				bool moveSlow = JmgUtility::SimpleDistance(Commands->Get_Position(obj),Commands->Get_Position(player)) < 625.0f;
+				if (moveSlow != movingSlow)
+					FollowPlayer(obj,moveSlow);
+			}
+		}
+		Commands->Start_Timer(obj,this,0.1f,92562343);
+	}
+}
+void JMG_Bear_Hunter_Friendly_Cougar::Damaged(GameObject *obj,GameObject *damager,float damage)
+{
+	if (!damager || Commands->Get_Player_Type(damager) != 1 || currentTargetID || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
+		return;
+	if (!chooseTarget(obj,damager,&currentTargetID,&LastSeen))
+		chooseTarget(obj,damager,&secondaryTargetId,&lastSeenSecondary);
+	else
+	{
+		huntorattack = 0;
+		waitcount = 0;
+	}
+}
+bool JMG_Bear_Hunter_Friendly_Cougar::chooseTarget(GameObject *obj,GameObject *damager,int *compareId,int *seenTimer)
+{
+	GameObject *target = Commands->Find_Object(*compareId);
+	if (target)
+	{
+		float targetDistance = JmgUtility::SimpleDistance(Commands->Get_Position(obj),Commands->Get_Position(target));
+		float damagerDistance = JmgUtility::SimpleDistance(Commands->Get_Position(obj),Commands->Get_Position(damager));
+		if (targetDistance < damagerDistance)
+			return false;
+	}
+	*seenTimer = minVisibilityTime == maxVisibilityTime ? maxVisibilityTime : Commands->Get_Random_Int(minVisibilityTime,maxVisibilityTime);
+	*compareId = Commands->Get_ID(damager);
+	return true;
+}
+void JMG_Bear_Hunter_Friendly_Cougar::FollowPlayer(GameObject *obj,bool moveSlow)
+{
+	waitcount = 0;
+	currentTargetID = 0;
+	Commands->Action_Reset(obj,10);
+	ActionParamsStruct params;
+	params.Set_Basic(this,999,10);
+	GameObject *player = JmgUtility::FindNearestPlayer(Commands->Get_Position(obj));
+	movingSlow = moveSlow;
+	params.Set_Movement(player,movingSlow ? 0.15f : Get_Float_Parameter("ReturnHomeSpeed"),Get_Float_Parameter("ReturnHomeArriveDistance"),false);
+	params.MoveFollow = true;
+	Commands->Action_Goto(obj,params);
+	gotoId = Commands->Get_ID(player);
+}
+void JMG_Bear_Hunter_SpawnPoint_Final_Boss_Line_Of_Sight::Created(GameObject *obj)
+{
+	Rp2SimplePositionSystem::SimplePositionNode *node = new Rp2SimplePositionSystem::SimplePositionNode(obj,Get_Int_Parameter("Value"));
+	bossSpawnProtectionPoints += node;
+	Commands->Destroy_Object(obj);
+}
+void JMG_Bear_Hunter_SpawnPoint_Final_Boss::Created(GameObject *obj)
+{
+	Rp2SimplePositionSystem::SimplePositionNode *node = new Rp2SimplePositionSystem::SimplePositionNode(obj,Get_Int_Parameter("Value"));
+	randomSelectableSpawnPoints[4] += node;
+	Commands->Destroy_Object(obj);
+}
 ScriptRegistrant<JMG_Bear_Hunter_Player_Soldier> JMG_Bear_Hunter_Player_Soldier_Registrant("JMG_Bear_Hunter_Player_Soldier","");
 ScriptRegistrant<JMG_Rp2_Dedicated_Server_Sound_Emulator> JMG_Rp2_Dedicated_Server_Sound_Emulator_Registrant("JMG_Rp2_Dedicated_Server_Sound_Emulator","");
 ScriptRegistrant<JMG_Bear_Hunter_Game_Control> JMG_Bear_Hunter_Game_Control_Registrant("JMG_Bear_Hunter_Game_Control","PositionFile=DhSwampDeerPositions.ecw:string");
@@ -7986,9 +8857,13 @@
 ScriptRegistrant<JMG_Bear_Hunter_Wolf> JMG_Bear_Hunter_Wolf_Registrant("JMG_Bear_Hunter_Wolf","WolfPackID:int,ControllerId:int");
 ScriptRegistrant<JMG_Bear_Hunter_Wolf_Wander_Point> JMG_Bear_Hunter_Wolf_Wander_Point_Registrant("JMG_Bear_Hunter_Wolf_Wander_Point","WolfPackID:int");
 ScriptRegistrant<JMG_Bear_Hunter_Armored_Car> JMG_Bear_Hunter_Armored_Car_Registrant("JMG_Bear_Hunter_Armored_Car","");
+ScriptRegistrant<JMG_Bear_Hunter_Armored_Car_Controller> JMG_Bear_Hunter_Armored_Car_Controller_Registrant("JMG_Bear_Hunter_Armored_Car_Controller","");
 ScriptRegistrant<JMG_Bear_Hunt_Final_Boss_Support> JMG_Bear_Hunt_Final_Boss_Support_Registrant("JMG_Bear_Hunt_Final_Boss_Support","");
 ScriptRegistrant<JMG_Bear_Hunter_Golden_Deer_Statue> JMG_Bear_Hunter_Golden_Deer_Statue_Registrant("JMG_Bear_Hunter_Golden_Deer_Statue","");
 ScriptRegistrant<JMG_Bear_Hunter_Golden_Deer_Statue_Standin> JMG_Bear_Hunter_Golden_Deer_Statue_Standin_Registrant("JMG_Bear_Hunter_Golden_Deer_Statue_Standin","");
 ScriptRegistrant<JMG_Bear_Hunter_Golden_Deer_Statue_Attached> JMG_Bear_Hunter_Golden_Deer_Statue_Attached_Registrant("JMG_Bear_Hunter_Golden_Deer_Statue_Attached","");
 ScriptRegistrant<JMG_Bear_Hunter_AI_Avoid_Enemies> JMG_Bear_Hunter_AI_Avoid_Enemies_Registrant("JMG_Bear_Hunter_AI_Avoid_Enemies","");
-ScriptRegistrant<JMG_Security_Camera_Behavior_Ignore> JMG_Security_Camera_Behavior_Ignore_Registrant("JMG_Security_Camera_Behavior_Ignore","");
\ No newline at end of file
+ScriptRegistrant<JMG_Security_Camera_Behavior_Ignore> JMG_Security_Camera_Behavior_Ignore_Registrant("JMG_Security_Camera_Behavior_Ignore","");
+ScriptRegistrant<JMG_Bear_Hunter_Friendly_Cougar> JMG_Bear_Hunter_Friendly_Cougar_Registrant("JMG_Bear_Hunter_Friendly_Cougar","ReturnHomeSpeed=1.0:float,ReturnHomeArriveDistance=1.0:float,ChaseSpeed=1.0:float,AttackArriveDistance=0.0:float,StartAttackDistance=3.0:float,MaxHuntDistance=0.0:float,MinLooseVisibilityTime=3:int,MaxLooseVisibilityTime=6:int,NoPathfindDistance=5.0:float");
+ScriptRegistrant<JMG_Bear_Hunter_SpawnPoint_Final_Boss_Line_Of_Sight> JMG_Bear_Hunter_SpawnPoint_Final_Boss_Line_Of_Sight_Registrant("JMG_Bear_Hunter_SpawnPoint_Final_Boss_Line_Of_Sight","Value:int");
+ScriptRegistrant<JMG_Bear_Hunter_SpawnPoint_Final_Boss> JMG_Bear_Hunter_SpawnPoint_Final_Boss_Registrant("JMG_Bear_Hunter_SpawnPoint_Final_Boss","Value:int");
diff -ur sourceold/scripts/jmgMetroid.cpp source/scripts/jmgMetroid.cpp
--- sourceold/scripts/jmgMetroid.cpp	2019-06-22 07:43:44.241400000 +1000
+++ source/scripts/jmgMetroid.cpp	2019-08-20 10:11:06.810000100 +1000
@@ -307,6 +307,7 @@
 }
 void JMG_Metroid_Game_Control::IncreasePlayerTimeScores()
 {
+	JmgUtility::GenericDateTime currentTime = JmgUtility::GenericDateTime();
 	for (int y = 1;y < 128;y++)
 	{
 		GameObject *Player = Get_GameObj(y);
@@ -324,6 +325,7 @@
 		if (abs(Facing - pobj->LastFacing) < 1.0f)
 			IsTurning = false;
 		pobj->LastFacing = Facing;
+		pobj->LastPlayTime = currentTime;
 		if (pobj->IsMoving == IsMoving && pobj->IsTurning == IsTurning)
 			if (pobj->IdleDelay > 60)
 			{
@@ -5189,14 +5191,21 @@
 }
 void JMG_AI_Artillery_Targeting_Fire_Vehicle_Projectile_Attach::Created(GameObject *obj)
 {
-	Commands->Start_Timer(obj,this,0.025f,1);
+	Force_Position_Update(obj);
+	Force_Orientation_Update(obj);
+	Force_Velocity_Update(obj);
+	Update_Network_Object(obj);
+	Commands->Start_Timer(obj,this,0.1f,1);
 }
 void JMG_AI_Artillery_Targeting_Fire_Vehicle_Projectile_Attach::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
 	{
 		Force_Position_Update(obj);
-		Commands->Start_Timer(obj,this,0.025f,1);
+		Force_Orientation_Update(obj);
+		Force_Velocity_Update(obj);
+		Update_Network_Object(obj);
+		Commands->Start_Timer(obj,this,1.0f,1);
 	}
 }
 void JMG_AI_Artillery_Targeting_Fire_Vehicle_Projectile_Attach::Destroyed(GameObject *obj)
diff -ur sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2019-06-22 07:43:44.244400000 +1000
+++ source/scripts/jmgUtility.cpp	2019-08-20 10:11:06.814000100 +1000
@@ -10333,6 +10333,7 @@
 JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionSystem JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionControl[128] = {HerdAnimalPositionSystem()};
 void JMG_Utility_AI_Skittish_Herd_Animal::Created(GameObject *obj)
 {
+	actionCrouched = Get_Float_Parameter("ActionsCrouched");
 	weaponRange = 3.75;
 	sprintf(defaultWeapon,"%s",Get_Current_Weapon(obj));
 	int minHerdId = Get_Int_Parameter("MinHerdID");
@@ -10438,7 +10439,7 @@
 	params.Set_Movement(pos,speed ? speed : (Enemy ? 1.0f : Commands->Get_Random(0.25f,1.0f)),Enemy ? weaponRange*Commands->Get_Random(0.01f,1.0f) : 1.0f,false);
 	params.MovePathfind = true;
 	Vector3 mypos = Commands->Get_Position(obj);
-	if (!speed && JmgUtility::SimpleDistance(mypos,pos) < 625 && Commands->Get_Random(0.0f,1.0f) < 0.25f)
+	if (!speed && JmgUtility::SimpleDistance(mypos,pos) < 625 && Commands->Get_Random(0.0f,1.0f) < actionCrouched)
 	{
 		params.MoveCrouched = true;
 		params.AttackCrouched = true;
@@ -12115,6 +12116,38 @@
 		}
 	}
 }
+void JMG_Utility_Player_Seen_Send_Custom::Created(GameObject *obj)
+{
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("Custom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	triggerOnce = Get_Int_Parameter("TriggerOnce") != 0;
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Player_Seen_Send_Custom::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		for (int x = 1;x < 128;x++)
+		{
+			GameObject *player = Get_GameObj(x);
+			if (!player || Commands->Get_Player_Type(player) == -4)
+				continue;
+			SmartGameObj *smartGameObject = player->As_SmartGameObj();
+			if (!smartGameObject || !smartGameObject->Is_Visible())
+				continue;
+			if (obj->As_SmartGameObj()->Is_Obj_Visible(smartGameObject))
+			{
+				GameObject *object = id ? (id == -1 ? player : Commands->Find_Object(id)) : obj;
+				Commands->Send_Custom_Event(obj,object,custom,Param == -1 ? Commands->Get_ID(player) : Param,delay);
+				if (triggerOnce)
+					Destroy_Script();
+			}
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
 ScriptRegistrant<JMG_Utility_Check_If_Script_Is_In_Library> JMG_Utility_Check_If_Script_Is_In_Library_Registrant("JMG_Utility_Check_If_Script_Is_In_Library","ScriptName:string,CppName:string");
 ScriptRegistrant<JMG_Send_Custom_When_Custom_Sequence_Matched> JMG_Send_Custom_When_Custom_Sequence_Matched_Registrant("JMG_Send_Custom_When_Custom_Sequence_Matched","Success_Custom=0:int,Correct_Step_Custom=0:int,Partial_Failure_Custom=0:int,Failure_Custom=0:int,Send_To_ID=0:int,Custom_0=0:int,Custom_1=0:int,Custom_2=0:int,Custom_3=0:int,Custom_4=0:int,Custom_5=0:int,Custom_6=0:int,Custom_7=0:int,Custom_8=0:int,Custom_9=0:int,Disable_On_Success=1:int,Disable_On_Failure=0:int,Starts_Enabled=1:int,Enable_Custom=0:int,Correct_Step_Saftey=0:int,Failure_Saftey=1:int,Max_Failures=1:int");
 ScriptRegistrant<JMG_Utility_Change_Model_On_Timer> JMG_Utility_Change_Model_On_Timer_Registrant("JMG_Utility_Change_Model_On_Timer","Model=null:string,Time=0:float");
@@ -12365,7 +12398,7 @@
 ScriptRegistrant<JMG_Utility_Timer_Trigger_Enemy_Seen> JMG_Utility_Timer_Trigger_Enemy_Seen_Registrant("JMG_Utility_Timer_Trigger_Enemy_Seen","Scan_Rate=0.1:float");
 ScriptRegistrant<JMG_Utility_Custom_Teleport_To_Random_Wander_Point> JMG_Utility_Custom_Teleport_To_Random_Wander_Point_Registrant("JMG_Utility_Custom_Teleport_To_Random_Wander_Point","Custom:int,WanderingAIGroupID=-1:int,SafeTeleportDistance=1.5:float,RetryOnFailure=0:int");
 ScriptRegistrant<JMG_Utility_Send_Custom_If_Not_Moving_Enough> JMG_Utility_Send_Custom_If_Not_Moving_Enough_Registrant("JMG_Utility_Send_Custom_If_Not_Moving_Enough","Time:float,Distance:float,ID=0:int,SendCustom:int,Param:int,Delay=0.0:float");
-ScriptRegistrant<JMG_Utility_AI_Skittish_Herd_Animal> JMG_Utility_AI_Skittish_Herd_Animal_Registrant("JMG_Utility_AI_Skittish_Herd_Animal","MinHerdID=0:int,MaxHerdID=0:int,WanderGroupID=0:int,WanderRadiusAroundHerdCenter=25.0:float,MinWanderFrequency=5.0:float,MaxWanderFrequency=30.0:float,MinRetreatRange=50.0:float,MaxRetreatRange=200.0:float,MinRetreatTime=6.0:float,MaxRetreatTime=24.0:float,MinUpdateHerdCenter=10.0:float,MaxUpdateHerdCenter=25.0:float,RunTowardThreatChance=0.0:float");
+ScriptRegistrant<JMG_Utility_AI_Skittish_Herd_Animal> JMG_Utility_AI_Skittish_Herd_Animal_Registrant("JMG_Utility_AI_Skittish_Herd_Animal","MinHerdID=0:int,MaxHerdID=0:int,WanderGroupID=0:int,WanderRadiusAroundHerdCenter=25.0:float,MinWanderFrequency=5.0:float,MaxWanderFrequency=30.0:float,MinRetreatRange=50.0:float,MaxRetreatRange=200.0:float,MinRetreatTime=6.0:float,MaxRetreatTime=24.0:float,MinUpdateHerdCenter=10.0:float,MaxUpdateHerdCenter=25.0:float,RunTowardThreatChance=0.0:float,ActionsCrouched=0.25:float");
 ScriptRegistrant<JMG_Utility_AI_Skittish_Herd_Animal_Ignore> JMG_Utility_AI_Skittish_Herd_Animal_Ignore_Registrant("JMG_Utility_AI_Skittish_Herd_Animal_Ignore","");
 ScriptRegistrant<JMG_Utility_AI_Skittish_Herd_Animal_Controller> JMG_Utility_AI_Skittish_Herd_Animal_Controller_Registrant("JMG_Utility_AI_Skittish_Herd_Animal_Controller","");
 ScriptRegistrant<JMG_Utility_Custom_Display_Dialog_Box> JMG_Utility_Custom_Display_Dialog_Box_Registrant("JMG_Utility_Custom_Display_Dialog_Box","Custom:int,Message:string,Delim=@:string");
@@ -12402,3 +12435,4 @@
 ScriptRegistrant<JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom> JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom_Registrant("JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom","TargetCustom:int,MinDistance=0.0:float,MinAngle=-90.0:float,MaxAngle=90.0:float,UseLowAngleMaxDistance=0.0:float,UseLowAngleWhenAboveMinDistance=1:int,UseLowAngleTargetAboveHeight=9999.9:float,VehicleProjectilePreset:string,FireVelocity=1.0:float,GravityScale=1.0:float,MissAmountPerMeter=0.0:float,BaseMissAmount=0.0:float,ProjectedShotsChance=1.0:float,FireRate=1.0:float,ReloadTime=1.0:float,ReloadSound=null:string,ClipCount=1:int,FireSound=null:string,MuzzleFlashExplosion=null:string,ProjectileExplosion=null:string,CustomTimeoutTime=3:int,AimTurret=1:int");
 ScriptRegistrant<JMG_Utility_Vehicle_Enter_Send_Custom_From_Enterer> JMG_Utility_Vehicle_Enter_Send_Custom_From_Enterer_Registrant("JMG_Utility_Vehicle_Enter_Send_Custom_From_Enterer","PlayerType=2:int,ID:int,Custom:int,Param:int,Delay:float,TriggerOnce:int");
 ScriptRegistrant<JMG_Utility_Custom_Send_Custom_On_Count_From_Sender> JMG_Utility_Custom_Send_Custom_On_Count_From_Sender_Registrant("JMG_Utility_Custom_Send_Custom_On_Count_From_Sender","Custom:int,Count:int,ID=0:int,SendCustom:int,Param:int,Delay:float,ResetCustom:int");
+ScriptRegistrant<JMG_Utility_Player_Seen_Send_Custom> JMG_Utility_Player_Seen_Send_Custom_Registrant("JMG_Utility_Player_Seen_Send_Custom","ID:int,Custom:int,Param:int,Delay:float,TriggerOnce:int");
\ No newline at end of file
